Attribute VB_Name = "JK95sub"
Option Explicit

Global midiname As String ', crlf As String

Sub PrtLyric(intex As String)
    VBSYXSUM.Text1.Text = VBSYXSUM.Text1.Text & vbCrLf & Space(10) & intex
End Sub

Sub ShowLyrics()
    Dim xx As Integer, yy As Long, zz As Integer
    Dim x1 As Long, z1 As Integer
    Dim rst As String, lyrics As String

    If Len(VBSYXSUM.mf1.filename) = 0 Then Exit Sub
    rst = VBSYXSUM.mf1.filename
    VBSYXSUM.mf1.Action = MIDIFILE_OPEN ' open existing file
    VBSYXSUM.Caption = "MIDI Jukebox Lyric Display - " + rst
    VBSYXSUM.Text1.Text = ""
    PrtLyric " File name: " + VBSYXSUM.mf1.filename
    PrtLyric " No of tracks: " + Str$(VBSYXSUM.mf1.NumberOfTracks)
    PrtLyric " Track Format: " + Str$(VBSYXSUM.mf1.Format) + " Time Format: " + Str$(VBSYXSUM.mf1.TimeFormat) + vbCrLf
    lyrics = ""
    zz = 0 ' SHOW flag
    For xx = 1 To VBSYXSUM.mf1.NumberOfTracks
        DoEvents
        VBSYXSUM.mf1.TrackNumber = xx
        x1 = VBSYXSUM.mf1.MessageCount
        'PrtLyric " " + Right$("  " + Str$(xx), 3) + " Messages: " + Right$("    " + Str$(x1), 6) + vbCrLf
        For yy = 1 To x1
            VBSYXSUM.mf1.MessageNumber = yy
            If (yy Mod 1000) = 0 Then
                ' PrtLyric Str$(yy)
            End If
            If VBSYXSUM.mf1.Message = &HFF And VBSYXSUM.mf1.Data2 = 5 Then ' ???
                z1 = VBSYXSUM.mf1.Data1 ' do nothing
            End If
            If VBSYXSUM.mf1.Message = &HFF And VBSYXSUM.mf1.Data1 = 5 Then ' Text ie Lyric
                rst = VBSYXSUM.mf1.MsgText
                If Len(rst) = 0 Then rst = " "
                For z1 = 1 To Len(rst)
                    Select Case Asc(Mid$(rst, z1, 1))
                        Case 13: ' CR
                            PrtLyric lyrics
                            lyrics = ""
                            If zz = 0 Then
                                zz = 1
                                VBSYXSUM.Show
                            End If
                            DoEvents
                        Case 10: ' LF
                            PrtLyric ""
                        Case Else:
                            lyrics = lyrics + Mid$(rst, z1, 1)
                    End Select
                Next z1
            End If
            If VBSYXSUM.mf1.Message = &HFF And VBSYXSUM.mf1.Data1 = 1 Then ' Text ie Karaoke
                rst = VBSYXSUM.mf1.MsgText
                If Len(rst) = 0 Then rst = " "
                For z1 = 1 To Len(rst)
                    Select Case Asc(Mid$(rst, z1, 1))
                        Case 47: ' / ie CR
                            PrtLyric lyrics
                            lyrics = ""
                            If zz = 0 Then
                                zz = 1
                                VBSYXSUM.Show
                            End If
                            DoEvents
                        Case 92: ' \ ie LF
                            PrtLyric lyrics
                            lyrics = vbCrLf & Space(10)
                            'z1 = Len(rst)
                        Case 64: ' @ ie title
                            If Mid$(rst, 2, 1) = "T" Then
                                'PrtLyric Mid$(rst, 3, Len(rst) - 2)
                            End If
                            z1 = Len(rst)
                        Case Else:
                            lyrics = lyrics + Mid$(rst, z1, 1)
                    End Select
                Next z1
            End If
        Next yy
    Next xx
    If lyrics <> "" Then PrtLyric lyrics
    VBSYXSUM.mf1.Action = MIDIFILE_CLOSE     ' close
    If VBSYXSUM.Text1.Text = "" Then
        VBSYXSUM.Text1.Text = Chr$(13) + Chr$(10) + Space(10) + "There are no lyrics in this file"
    Else
        PrtLyric ""
    End If
End Sub

