VERSION 5.00
Object = "{852E65AD-72F8-11CF-840E-444553540000}#1.1#0"; "MIDIIO32.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "MIDI Input Monitor"
   ClientHeight    =   6195
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   5475
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6195
   ScaleWidth      =   5475
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Clear Midi In Display"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3120
      TabIndex        =   6
      Top             =   5760
      Width           =   2295
   End
   Begin VB.CheckBox Check1 
      Caption         =   "Display Midi Input?"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   5760
      Width           =   2055
   End
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   3240
      Top             =   3480
   End
   Begin MidiioLib.MIDIOutput MIDIOutput1 
      Left            =   4440
      Top             =   3480
      _Version        =   65537
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      DeviceID        =   0
      VolumeLeft      =   -1
      VolumeRight     =   -1
   End
   Begin MidiioLib.MIDIInput MIDIInput1 
      Left            =   3840
      Top             =   3480
      _Version        =   65537
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      MessageEventEnable=   -1  'True
      MaxSysexSize    =   31000
   End
   Begin VB.TextBox Text1 
      Height          =   5055
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   480
      Width           =   5415
   End
   Begin VB.Label OutStatus 
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   4440
      TabIndex        =   4
      Top             =   120
      Width           =   615
   End
   Begin VB.Label Label2 
      Caption         =   "Midi Out Status"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   2640
      TabIndex        =   3
      Top             =   120
      Width           =   1455
   End
   Begin VB.Label InStatus 
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   1800
      TabIndex        =   2
      Top             =   120
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Midi In Status"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1455
   End
   Begin VB.Menu File 
      Caption         =   "&File"
      Begin VB.Menu MIDISetup 
         Caption         =   "MIDI &Setup"
      End
      Begin VB.Menu line1 
         Caption         =   "-"
      End
      Begin VB.Menu Exit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu MIDI 
      Caption         =   "&Options"
      Begin VB.Menu NoNotes 
         Caption         =   "&Prevent Duplicate Notes?"
         Checked         =   -1  'True
      End
      Begin VB.Menu NoReset 
         Caption         =   "&Disable GM/XG/GS Resets?"
      End
      Begin VB.Menu NoDebug 
         Caption         =   "Debug?"
         Visible         =   0   'False
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Command1_Click()
    Text1.Text = ""
End Sub

Private Sub Exit_Click()
    Unload Me
End Sub

Private Sub Form_Click()
    Me.Caption = "Error in Note On - count: " + Str$(ErrCount)
    DoEvents
    WaitaSec (1.1)
    DoEvents
    Me.Caption = "MIDI Input Monitor"
End Sub

Private Sub Form_Load()
    Dim xx As Integer
    
    Screen.MousePointer = 11
    Top = Screen.Height / 2 - Me.Height / 2
    Left = Screen.Width / 2 - Me.Width / 2
    '
    Screen.MousePointer = 0
    Text1.Text = ""
    ' Load MIDISetupForm
    MIDISetupForm.Show vbModal
    'xx = ChooseMIDI
    Me.Show
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim xx As Integer

    If Me.MIDIInput1.State <> MIDISTATE_CLOSED Then
        MIDIInput1.Action = MIDIIN_STOP
        MIDIInput1.Action = MIDIIN_CLOSE
    End If
    If Me.MIDIOutput1.State <> MIDISTATE_CLOSED Then
        MIDIOutput1.Action = MIDIOUT_CLOSE
    End If
    'close all sub forms
    For xx = Forms.Count - 1 To 1 Step -1
        Unload Forms(xx)
    Next xx
End Sub

Private Sub MIDIInput1_Error(ErrorCode As Integer, ErrorMessage As String)
   If (ErrorCode <> 0) And (ErrorCode <> 8) Then
      MsgBox ErrorMessage
    End If
End Sub

Private Sub MIDIInput1_Message()
    Dim InMessage As Integer
    Dim InData1 As Integer
    Dim InData2 As Integer
    Dim xx As Integer, yy As Integer, zz As Integer
    Dim xcol As Long, rst As String

    ' Process all notes on input queue
    Do While MIDIInput1.MessageCount > 0
        DoEvents
        InMessage = MIDIInput1.Message
        InData1 = MIDIInput1.Data1
        InData2 = MIDIInput1.Data2
        DoEvents
        If InMessage >= SYSEX Or InMessage < 0 Then ' Special MIDI IN
            ' InMessage appears to be &HFFF0 for SYSEX?
            If Len(MIDIInput1.Buffer) = 0 Then ' Not SYSEX
                MIDIInput1.Action = MIDIIN_REMOVE
                DoEvents
                GoTo endinputloop
            End If
            pianosyx = MIDIInput1.Buffer
            MIDIInput1.Action = MIDIIN_REMOVE
            DoEvents
            rst = pianosyx + "          "
            ' Test GS, GM, XG and SC-88 Reset
            If Mid$(rst, 6, 3) = (Chr$(&H40) + Chr$(&H0) + Chr$(&H7F)) _
            Or Mid$(rst, 2, 2) = (Chr$(&H7E) + Chr$(&H7F)) _
            Or Mid$(rst, 5, 3) = (Chr$(&H0) + Chr$(&H0) + Chr$(&H7E)) _
            Or Mid$(rst, 6, 3) = (Chr$(&H0) + Chr$(&H0) + Chr$(&H7F)) Then
                If Me.NoReset.Checked = True Then GoTo endinputloop
            End If
            If MIDIOutput1.State = MIDISTATE_OPEN Then
                MIDIOutput1.Message = &HF0
                MIDIOutput1.Buffer = pianosyx
                MIDIOutput1.Action = MIDIOUT_SEND
                DoEvents
            End If
            Text1.Text = Text1.Text & "SYSEX" & vbCrLf
            GoTo endinputloop
            ' Exit Sub
        End If
        MIDIInput1.Action = MIDIIN_REMOVE
        DoEvents
        yy = InMessage And &HF ' yy = channel
        If InMessage >= NOTE_OFF _
        And InMessage <= NOTE_ON + &HF Then ' This is a note
            If InMessage >= NOTE_ON Then ' this is a Note On
                If NoteOn(yy, InData1) = 1 Then
                ' this should NOT happen unless Note On value=0 ie Note Off!
                    If InData2 <> 0 Then
                        ErrCount = ErrCount + 1
                        If Me.NoDebug.Checked = True Then
                            Me.Caption = "Error in noteon - count: " + Str$(ErrCount)
                        End If
                        If Me.NoNotes.Checked = True Then GoTo endinputloop
                    Else ' Value=0 ie Note Off!
                        NoteOn(yy, InData1) = 0 ' turn off bitmap
                    End If
                Else ' this is normal :-)
                    If InData2 <> 0 Then NoteOn(yy, InData1) = 1 ' turn on  bitmap
                End If
            Else ' this is a Note Off
                NoteOn(yy, InData1) = 0 ' turn off bitmap
            End If
        End If
        DoEvents
        If MIDIOutput1.State = MIDISTATE_OPEN Then
            MIDIOutput1.Message = InMessage
            MIDIOutput1.Data1 = InData1
            MIDIOutput1.Data2 = InData2
            MIDIOutput1.Action = MIDIOUT_SEND
        End If
        If Check1.Value = vbChecked Then
            Text1.Text = Text1.Text & Hex$(InMessage) & " " & Hex$(InData1) & " " & Hex$(InData2) & vbCrLf
        End If
        DoEvents
endinputloop: 'Do nothing - messy code!
    DoEvents
    Loop
End Sub

Private Sub MIDISetup_Click()
    MIDISetupForm.Show vbModal
End Sub

Private Sub NoDebug_Click()
    NoDebug.Checked = Not NoDebug.Checked
End Sub

Private Sub NoNotes_Click()
    NoNotes.Checked = Not NoNotes.Checked
End Sub

Private Sub NoReset_Click()
    NoReset.Checked = Not NoReset.Checked
End Sub

Private Sub Timer1_Timer()
    InStatus = Str$(MIDIInput1.State)
    OutStatus = Str$(MIDIOutput1.State)
    DoEvents
End Sub
