VERSION 5.00
Begin VB.Form MIDISetupForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "MIDI Devices"
   ClientHeight    =   1200
   ClientLeft      =   1575
   ClientTop       =   4350
   ClientWidth     =   7500
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Icon            =   "MIDISET.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1200
   ScaleWidth      =   7500
   Begin VB.CommandButton CmdCancel 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Cancel"
      Height          =   375
      Left            =   6400
      TabIndex        =   5
      Top             =   690
      Width           =   1005
   End
   Begin VB.CommandButton CmdOk 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Ok"
      Height          =   375
      Left            =   6400
      TabIndex        =   4
      Top             =   240
      Width           =   1005
   End
   Begin VB.ComboBox ComboMidiOut 
      Appearance      =   0  'Flat
      Height          =   315
      Left            =   3300
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   540
      Width           =   3000
   End
   Begin VB.ComboBox ComboMidiIn 
      Appearance      =   0  'Flat
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   540
      Width           =   3000
   End
   Begin VB.Label Label2 
      Caption         =   "MIDI Out Device"
      Height          =   255
      Left            =   3300
      TabIndex        =   3
      Top             =   240
      Width           =   2025
   End
   Begin VB.Label Label1 
      Caption         =   "MIDI In Device"
      Height          =   255
      Left            =   150
      TabIndex        =   2
      Top             =   240
      Width           =   2115
   End
End
Attribute VB_Name = "MIDISetupForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub CmdCancel_Click()
    ' Unload MIDISetupForm
    MIDISetupForm.Hide
End Sub

Private Sub CmdOk_Click()
    Dim xx As Integer
    
    InputName = ComboMidiIn.List(ComboMidiIn.ListIndex)
    OutputName = ComboMidiOut.List(ComboMidiOut.ListIndex)
    inputport = ComboMidiIn.ListIndex
    outputport = ComboMidiOut.ListIndex
    xx = ChooseMIDI
    MIDISetupForm.Hide
End Sub

Private Sub Form_Load()
    Dim I As Integer, xx As Integer, yy As Integer
   
    ' Center the form on the screen
    Move (Screen.Width - Width) \ 2, (Screen.Height - Height) \ 2
    '
    ' Fill output device combo box
    '
    ComboMidiOut.AddItem "Not Enabled"
    yy = 0
    For I = -1 To Form1.MIDIOutput1.DeviceCount - 1
        Form1.MIDIOutput1.DeviceID = I
        ComboMidiOut.AddItem Form1.MIDIOutput1.ProductName
        If Form1.MIDIOutput1.ProductName = OutputName Then yy = I + 2
    Next
    '
    ' Select first in list or last driver used
    '
    outputport = yy
    ComboMidiOut.ListIndex = yy
    '
    ' Fill input device combo box
    '
    ComboMidiIn.AddItem "Not Enabled"
    xx = 0
    For I = 0 To Form1.MIDIInput1.DeviceCount - 1
        Form1.MIDIInput1.DeviceID = I
        ComboMidiIn.AddItem Form1.MIDIInput1.ProductName
        If Form1.MIDIInput1.ProductName = InputName Then xx = I + 1
    Next
    '
    ' Select first in list or last driver used
    '
    inputport = xx
    ComboMidiIn.ListIndex = xx
End Sub

