VERSION 5.00
Object = "{291F0443-8437-11CF-840F-444553540000}#1.1#0"; "MIDIFL32.OCX"
Begin VB.Form VBSYXSUM 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFF00&
   Caption         =   "MIDI Jukebox - Lyrics Display"
   ClientHeight    =   6030
   ClientLeft      =   510
   ClientTop       =   690
   ClientWidth     =   8550
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Icon            =   "VBSYXSUM.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   6030
   ScaleWidth      =   8550
   Begin MidifileLib.Midifile mf1 
      Left            =   3960
      Top             =   5520
      _Version        =   65537
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      Filename        =   ""
   End
   Begin VB.TextBox Text1 
      Appearance      =   0  'Flat
      BackColor       =   &H00FFFF00&
      Height          =   5400
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   8535
   End
End
Attribute VB_Name = "VBSYXSUM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Activate()
    
    Text1.SelLength = 0
    Text1.SetFocus
End Sub

Private Sub Form_Click()
    
    VBSYXSUM.Hide
End Sub

Private Sub Form_KeyDown(Keycode As Integer, Shift As Integer)
    
    If Keycode = 27 Then VBSYXSUM.Hide ' Esc
    If Keycode = 33 Or Keycode = 34 Then ' PageUp or PageDn
        Text1.SetFocus
    End If
End Sub

Private Sub Form_Load()
    
    ScaleMode = 1
    ' The form is horizontally and vertically centered when loaded
    Top = Screen.Height / 20 ' - Height / 2
    Left = Screen.Width / 2 - Width / 2
End Sub

Private Sub Form_Resize()
    Dim ht As Long
    
    On Error Resume Next
    Text1.Width = ScaleWidth ' * .98
    ht = VBSYXSUM.Height - 400
    If ht < 1 Then ht = 100
    Text1.Height = ht
End Sub

Private Sub mf1_Error(ErrorCode As Integer, ErrorMessage As String)
    MsgBox ErrorMessage
End Sub

Private Sub Text1_KeyPress(Keyascii As Integer)
    
    ' MsgBox Str$(Keyascii)
    ' If Keyascii = 13 Then ' Enter key
    Keyascii = 0
End Sub

