Attribute VB_Name = "PIANO1"
Option Explicit
'
'Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Global pianosyx As String
'
Global NoteOn(0 To 15, 0 To 127) As Integer
' bitmap for noteon events per channel and note value
Global ErrCount As Long
'
' MIDI In and Out ports
Global InputName As String, OutputName As String
Global inputport As Integer, outputport As Integer

Function ChooseMIDI() As Integer
    Dim xx As Integer
        
    ' MIDI In
    If Form1.MIDIInput1.State <> MIDISTATE_CLOSED Then
        Form1.MIDIInput1.Action = MIDIIN_STOP
        Form1.MIDIInput1.Action = MIDIIN_CLOSE
    End If
    If inputport <> 0 Then
        MIDIInOpen
        If Form1.MIDIInput1.State = MIDISTATE_CLOSED And MIDISetupForm.ComboMidiIn.ListIndex > 0 Then
            ChooseMIDI = 0
            Exit Function
        End If
    End If
    ' MIDI Out
    If Form1.MIDIOutput1.State <> MIDISTATE_CLOSED Then
        Form1.MIDIOutput1.Action = MIDIOUT_CLOSE
    End If
    If outputport <> 0 Then
        MIDIOutOpen
        If Form1.MIDIOutput1.State = MIDISTATE_CLOSED And MIDISetupForm.ComboMidiOut.ListIndex > 0 Then
            MsgBox "Cannot open MIDI Output port", vbExclamation, "Open MIDI Output port"
            ChooseMIDI = 0
            Exit Function
        End If
    End If
    If Form1.MIDIInput1.State <> MIDISTATE_CLOSED Then
        Form1.MIDIInput1.MessageEventEnable = True
    End If
    ChooseMIDI = 1
End Function

Sub MIDIInOpen()
    Dim wRtn As Integer
    
    If Form1.MIDIInput1.State >= MIDISTATE_OPEN Then
        ' Close midiin port
        Form1.MIDIInput1.Action = MIDIIN_CLOSE
    End If
    If MIDISetupForm.ComboMidiIn.ListIndex = 0 Then Exit Sub
    ' Get selected device id
    Form1.MIDIInput1.DeviceID = MIDISetupForm.ComboMidiIn.ListIndex - 1
    ' Open and display handle
    Form1.MIDIInput1.Action = MIDIIN_OPEN
    ' Start midi input
    Form1.MIDIInput1.Action = MIDIIN_START
    'note = 0
    Form1.MIDIInput1.Filter(FILTER_ACTIVE_SENSE) = True
End Sub

Sub MIDIOutOpen()

    If Form1.MIDIOutput1.State >= MIDISTATE_OPEN Or Form1.MIDIOutput1.DeviceID = -1 Then
        ' Close
        Form1.MIDIOutput1.Action = MIDIOUT_CLOSE
    End If
    If MIDISetupForm.ComboMidiOut.ListIndex = 0 Then Exit Sub
    ' Open selected device
    Form1.MIDIOutput1.DeviceID = MIDISetupForm.ComboMidiOut.ListIndex - 2
    Form1.MIDIOutput1.Action = MIDIOUT_OPEN
End Sub

Function szTrim(szString As String) As String
    Dim pos As Integer, ln As Integer

    pos = InStr(szString, Chr$(0))
    ln = Len(szString)
    Select Case pos
        Case Is > 1
            szTrim = Trim(Left(szString, pos - 1))
        Case 1
            szTrim = ""
        Case Else
            szTrim = Trim(szString)
    End Select
End Function

Sub WaitaSec(Amt As Long)
    Dim x1 As Long, x2 As Long

    x1 = Timer
    Do ' wait Amt seconds
        x2 = Timer
        DoEvents
    Loop Until x2 > x1 + Amt
End Sub

